/* Demonstrate signal handling by
   starting Emacs and waiting for it to finish.
   Busy-wait while waiting, illustrating
   how the signal arrives anyway. */

#include <unistd.h>
#include <signal.h>
#include <string.h>
#include <stdio.h>

extern char **environ;

volatile int stop;

void signal_handler()
{
  stop = 1;
}

int main()
{
  int pid;
  long c = 0;
  struct sigaction act, oact;
  
  memset(&act, 0, sizeof(sigaction));
  act.sa_sigaction = signal_handler;
  sigemptyset(&act.sa_mask);
  act.sa_flags = SA_SIGINFO;
  sigaction(SIGCHLD, &act, &oact);

  pid = fork();
  if (pid == 0) {
    /* child */
    char *argv[] = { "/usr/bin/emacs", NULL };
    execve(argv[0], argv, environ);
  }

  /* busy waiting is bad, but it illustrates that a signal
     is received when the child exits */
  while (!stop) {
    c++;
  }

  printf("%ld\n", c);
}
